import _extends from "@babel/runtime/helpers/esm/extends";
import React, { useContext } from 'react';
import { createEntity } from './createEntity';
import EntityContext from './EntityContext';
export var EntityScope = function EntityScope(_ref) {
  var entities = _ref.entities,
      children = _ref.children;
  var inheritedEntities = useContext(EntityContext);

  var instances = _extends({}, inheritedEntities);

  for (var k in entities) {
    var item = entities[k];
    var entity = item instanceof Array ? item[0] : item;
    var deps = item instanceof Array ? item[1] : undefined;
    instances[k] = createEntity(entity, deps);
  }

  return /*#__PURE__*/React.createElement(EntityContext.Provider, {
    value: instances
  }, children);
};
export default EntityScope;