import { useContext } from 'react';
import EntityContext from './EntityContext';
import useUnscopedEntity from './useUnscopedEntity';
export var useEntity = function useEntity(entity, selector, equalityFn) {
  var entities = useContext(EntityContext);
  if (typeof entity !== 'string' || !entities[entity]) throw new Error("Invalid entity reference: " + entity);
  return useUnscopedEntity(entities[entity], selector, equalityFn);
};
export default useEntity;